xref: /netbsd/usr.bin/lorder/lorder.sh (revision c4a72b64)
1#!/bin/sh -
2#	$NetBSD: lorder.sh,v 1.12 2002/09/14 05:00:58 thorpej Exp $
3#
4# Copyright (c) 1990, 1993
5#	The Regents of the University of California.  All rights reserved.
6#
7# Redistribution and use in source and binary forms, with or without
8# modification, are permitted provided that the following conditions
9# are met:
10# 1. Redistributions of source code must retain the above copyright
11#    notice, this list of conditions and the following disclaimer.
12# 2. Redistributions in binary form must reproduce the above copyright
13#    notice, this list of conditions and the following disclaimer in the
14#    documentation and/or other materials provided with the distribution.
15# 3. All advertising materials mentioning features or use of this software
16#    must display the following acknowledgement:
17#	This product includes software developed by the University of
18#	California, Berkeley and its contributors.
19# 4. Neither the name of the University nor the names of its contributors
20#    may be used to endorse or promote products derived from this software
21#    without specific prior written permission.
22#
23# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
24# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
25# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
26# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
27# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
28# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
29# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
30# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
31# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
32# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
33# SUCH DAMAGE.
34#
35#	@(#)lorder.sh	8.1 (Berkeley) 6/6/93
36#
37
38# If the user has set ${NM} then we use it, otherwise we use 'nm'.
39# We try to find the compiler in the user's path, and if that fails we
40# try to find it in the default path.  If we can't find it, we punt.
41# Once we find it, we canonicalize its name and set the path to the
42# default path so that other commands we use are picked properly.
43
44if [ "x${NM}" = "x" ]; then
45	NM=nm
46fi
47if ! type "${NM}" > /dev/null 2>&1; then
48	PATH=/bin:/usr/bin
49	export PATH
50	if ! type "${NM}" > /dev/null 2>&1; then
51		echo "lorder: ${NM}: not found" >&2
52		exit 1
53	fi
54fi
55cmd='set `type "${NM}"` ; eval echo \$$#'
56NM=`eval $cmd`
57
58if [ "x${MKTEMP}" = "x" ]; then
59	MKTEMP=mktemp
60fi
61if ! type "${MKTEMP}" > /dev/null 2>&1; then
62	PATH=/bin:/usr/bin
63	export PATH
64	if ! type "${MKTEMP}" > /dev/null 2>&1; then
65		echo "lorder: ${MKTEMP}: not found" >&2
66		exit 1
67	fi
68fi
69cmd='set `type "${MKTEMP}"` ; eval echo \$$#'
70MKTEMP=`eval $cmd`
71
72# only one argument is a special case, just output the name twice
73case $# in
74	0)
75		echo "usage: lorder file ..." >&2;
76		exit ;;
77	1)
78		echo $1 $1;
79		exit ;;
80esac
81
82# temporary files
83N=`${MKTEMP} /tmp/_nm_.XXXXXX` || exit 1
84R=`${MKTEMP} /tmp/_reference_.XXXXXX` || exit 1
85S=`${MKTEMP} /tmp/_symbol_.XXXXXX` || exit 1
86
87# remove temporary files on exit
88trap "rm -f $N $R $S; exit 0" 0
89trap "rm -f $N $R $S; exit 1" HUP INT QUIT PIPE TERM 2>/dev/null || \
90	trap "rm -f $N $R $S; exit 1" 1 2 3 13 15
91
92# if the line ends in a colon, assume it's the first occurrence of a new
93# object file.  Echo it twice, just to make sure it gets into the output.
94#
95# if the line has " T " or " D " it's a globally defined symbol, put it
96# into the symbol file.
97#
98# if the line has " U " it's a globally undefined symbol, put it into
99# the reference file.
100(for file in $* ; do echo $file":" ; done ; $NM -go $*) >$N
101sed -ne '/:$/{s/://;s/.*/& &/;p;}' <$N
102sed -ne 's/:.* [TDGR] / /p' <$N >$S
103sed -ne 's/:.* U / /p' <$N >$R
104
105# sort symbols and references on the first field (the symbol)
106# join on that field, and print out the file names.
107sort +1 $R -o $R
108sort +1 $S -o $S
109join -j 2 -o 1.1 2.1 $R $S
110